SystemOrganization addCategory: #'AL-Json-Canvas'!
SystemOrganization addCategory: #'AL-Json-Writer'!

!BlockClosure methodsFor: '*al-json-dispatch' stamp: 'cwp 3/14/2011 17:10'!
writeJsonWith: aWriter
	self value! !

Object subclass: #ALJsonBrush
	instanceVariableNames: 'canvas whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Json-Canvas'!

ALJsonBrush subclass: #ALJsonArrayBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Json-Canvas'!

!ALJsonArrayBrush methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 17:22'!
with: aBlock
	canvas whitespace: whitespace open: $[ do: aBlock close: $]
	! !

!ALJsonBrush class methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 15:42'!
on: aCanvas
	^ self basicNew initializeWithCanvas: aCanvas! !

!ALJsonBrush methodsFor: 'whitespace' stamp: 'cwp 3/14/2011 17:23'!
compact
	whitespace := ALJsonWhitespace compact! !

!ALJsonBrush methodsFor: 'whitespace' stamp: 'cwp 3/14/2011 17:21'!
eol: aString
	whitespace ifNil: [whitespace := ALJsonWhitespace new].
	whitespace eol: aString! !

!ALJsonBrush methodsFor: 'whitespace' stamp: 'cwp 3/14/2011 17:21'!
indent
	self indent: 2! !

!ALJsonBrush methodsFor: 'whitespace' stamp: 'cwp 3/14/2011 17:13'!
indent: anInteger
	whitespace ifNil: [whitespace := ALJsonWhitespace new].
	whitespace indent: anInteger! !

!ALJsonBrush methodsFor: 'initialize-release' stamp: 'cwp 3/14/2011 15:43'!
initializeWithCanvas: aCanvas
	self initialize.
	canvas := aCanvas! !

!ALJsonBrush methodsFor: 'whitespace' stamp: 'cwp 3/14/2011 17:26'!
space: aString
	whitespace ifNil: [whitespace := ALJsonWhitespace new].
	whitespace space: aString! !

!ALJsonBrush methodsFor: 'whitespace' stamp: 'cwp 3/14/2011 17:25'!
tab: aString
	whitespace ifNil: [whitespace := ALJsonWhitespace new].
	whitespace tab: aString! !

ALJsonBrush subclass: #ALJsonObjectBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Json-Canvas'!

!ALJsonObjectBrush methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 17:22'!
with: aBlock
	canvas whitespace: whitespace open: ${ do: aBlock close: $}
	! !

Object subclass: #ALJsonCanvas
	instanceVariableNames: 'writer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Json-Canvas'!

!ALJsonCanvas class methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 15:35'!
on: aWriteStream
	^ self basicNew initializeWithStream: aWriteStream! !

!ALJsonCanvas methodsFor: 'public' stamp: 'cwp 3/14/2011 17:19'!
array
	^ ALJsonArrayBrush on: writer! !

!ALJsonCanvas methodsFor: 'public' stamp: 'cwp 3/14/2011 16:51'!
array: aBlock
	writer array: aBlock! !

!ALJsonCanvas methodsFor: 'public' stamp: 'cwp 3/14/2011 16:53'!
flush
! !

!ALJsonCanvas methodsFor: 'initialize-release' stamp: 'cwp 3/14/2011 16:50'!
initializeWithStream: aWriteStream
	writer := ALJsonWriter on: aWriteStream.
	! !

!ALJsonCanvas methodsFor: 'public' stamp: 'cwp 3/14/2011 16:57'!
name: name value: value 
	writer name: name value: value! !

!ALJsonCanvas methodsFor: 'public' stamp: 'cwp 3/14/2011 17:24'!
object
	^ ALJsonObjectBrush on: writer! !

!ALJsonCanvas methodsFor: 'public' stamp: 'cwp 3/14/2011 16:57'!
object: aBlock
	writer object: aBlock! !

!ALJsonCanvas methodsFor: 'public' stamp: 'cwp 3/14/2011 16:51'!
value: anObject
	writer value: anObject! !

Object subclass: #ALJsonWhitespace
	instanceVariableNames: 'eol tab space indent whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Json-Writer'!

!ALJsonWhitespace class methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 16:15'!
compact
	^ self new! !

!ALJsonWhitespace methodsFor: 'public' stamp: 'cwp 3/14/2011 17:34'!
clear
	whitespace := ''! !

!ALJsonWhitespace methodsFor: 'public' stamp: 'cwp 3/14/2011 17:31'!
decreaseIndent
	indent := indent allButLast: tab size! !

!ALJsonWhitespace methodsFor: 'accessing' stamp: 'cwp 3/14/2011 16:15'!
eol
	^ eol! !

!ALJsonWhitespace methodsFor: 'accessing' stamp: 'cwp 3/14/2011 16:15'!
eol: anObject
	eol := anObject! !

!ALJsonWhitespace methodsFor: 'public' stamp: 'cwp 3/14/2011 16:17'!
generate
	whitespace := eol, indent! !

!ALJsonWhitespace methodsFor: 'public' stamp: 'cwp 3/14/2011 17:31'!
increaseIndent
	indent := indent , tab! !

!ALJsonWhitespace methodsFor: 'accessing' stamp: 'cwp 3/14/2011 17:33'!
indent: anInteger
	anInteger = 0
		ifTrue: 
			[space := ''.
			eol := ''.
			tab := '']
		ifFalse:  
			[tab := String new: anInteger.
			tab atAllPut: Character space.
			eol := String cr.
			space := String space]! !

!ALJsonWhitespace methodsFor: 'initialize-release' stamp: 'cwp 3/14/2011 16:15'!
initialize
	eol := tab := space := indent := whitespace := ''! !

!ALJsonWhitespace methodsFor: 'accessing' stamp: 'cwp 3/14/2011 16:15'!
space
	^ space! !

!ALJsonWhitespace methodsFor: 'accessing' stamp: 'cwp 3/14/2011 16:15'!
space: anObject
	space := anObject! !

!ALJsonWhitespace methodsFor: 'accessing' stamp: 'cwp 3/14/2011 16:15'!
tab
	^ tab! !

!ALJsonWhitespace methodsFor: 'accessing' stamp: 'cwp 3/14/2011 16:15'!
tab: anObject
	tab := anObject! !

!ALJsonWhitespace methodsFor: 'public' stamp: 'cwp 3/14/2011 16:16'!
writeInto: aWriteStream
	aWriteStream write: whitespace.
	whitespace := ''! !

Object subclass: #ALJsonWriter
	instanceVariableNames: 'stream whitespace separator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Json-Writer'!

!ALJsonWriter class methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 16:22'!
on: aWriteStream
	^ self basicNew initializeWithStream: aWriteStream ! !

!ALJsonWriter methodsFor: 'public' stamp: 'cwp 3/14/2011 16:46'!
array: aBlock
	self 
		whitespace: whitespace
		open: $[
		do: aBlock
		close: $]
			! !

!ALJsonWriter methodsFor: 'private' stamp: 'cwp 3/14/2011 16:53'!
decreaseIndent
	whitespace decreaseIndent.
	separator = ''
		ifTrue: [whitespace clear]
		ifFalse: [whitespace generate].
	whitespace writeInto: stream.! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 16:37'!
escape: aCharacter
	stream
		put: $\;
		put: aCharacter! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 16:44'!
hexEscape: aCharacter
	stream
		put: $\;
		put: $u;
		write: (aCharacter asciiValue printStringBase: 16 nDigits: 4)! !

!ALJsonWriter methodsFor: 'private' stamp: 'cwp 3/14/2011 16:48'!
increaseIndent
	whitespace 
		increaseIndent;
		generate! !

!ALJsonWriter methodsFor: 'initialize-release' stamp: 'cwp 3/14/2011 16:26'!
initializeWithStream: aWriteStream
	self initialize.
	stream := aWriteStream.
	whitespace := ALJsonWhitespace new.
	separator := ''.
! !

!ALJsonWriter methodsFor: 'public' stamp: 'cwp 3/14/2011 16:58'!
name: aString value: anObject
	self writeSeparator.
	self writeString: aString.
	stream put: $:.
	stream write: whitespace space.
	anObject writeJsonWith: self.
	self separateWithComma! !

!ALJsonWriter methodsFor: 'public' stamp: 'cwp 3/14/2011 16:46'!
object: aBlock
	self 
		whitespace: whitespace
		open: ${
		do: aBlock
		close: $}
			! !

!ALJsonWriter methodsFor: 'private' stamp: 'cwp 3/14/2011 16:48'!
separateWithComma
	separator := ','.
	whitespace generate! !

!ALJsonWriter methodsFor: 'private' stamp: 'cwp 3/14/2011 22:34'!
use: aWhitespace during: aBlock
	| old |
	[old := whitespace.
	whitespace := aWhitespace.
	aBlock value] ensure:
		[whitespace := old]! !

!ALJsonWriter methodsFor: 'public' stamp: 'cwp 3/14/2011 16:52'!
value: anObject
	self writeSeparator.
	anObject writeJsonWith: self.
	self separateWithComma! !

!ALJsonWriter methodsFor: 'private' stamp: 'cwp 3/14/2011 22:30'!
whitespace: aWhitespace open: open do: aBlock close: close
	self writeSeparator.
	self use: aWhitespace during:
		[stream put: open.
		self increaseIndent.
		aBlock value.
		self decreaseIndent.
		stream put: close].
	self separateWithComma
! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 16:55'!
writeArray: anArray 
	self array: [anArray do: [:ea | self value: ea]]! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 17:09'!
writeBoolean: aBoolean
	stream write: aBoolean printString! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 16:37'!
writeCharacter: aCharacter
	aCharacter = $" ifTrue: [^ self escape: $"].
	aCharacter = $\ ifTrue: [^ self escape: $\].
	aCharacter = Character backspace ifTrue: [^ self escape: $b].
	aCharacter = Character newPage ifTrue: [^ self escape: $f].
	aCharacter = Character lf ifTrue: [^ self escape: $n].
	aCharacter = Character cr ifTrue: [^ self escape: $r].
	aCharacter = Character tab ifTrue: [^ self escape: $t].
	aCharacter asciiValue < 32 ifTrue: [^ self hexEscape: aCharacter].
	stream put: aCharacter! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 17:04'!
writeInteger: anInteger 
	stream write: anInteger printString! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 17:10'!
writeNull
	stream write: 'null'! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 17:07'!
writeObject: aDictionary 
	self object:
		[aDictionary keysAndValuesDo: 
			[:key :value |
			self name: key value: value]]! !

!ALJsonWriter methodsFor: 'private' stamp: 'cwp 3/14/2011 16:30'!
writeSeparator
	stream write: separator.
	separator := ''.
	whitespace writeInto: stream! !

!ALJsonWriter methodsFor: 'types' stamp: 'cwp 3/14/2011 16:33'!
writeString: aString
	stream put: $".
	aString do: [:char | self writeCharacter: char].
	stream put: $".! !

!Dictionary methodsFor: '*al-json-dispatch' stamp: 'cwp 3/14/2011 17:05'!
writeJsonWith: aWriter
	aWriter writeObject: self! !

!UndefinedObject methodsFor: '*al-json-dispatch' stamp: 'cwp 3/14/2011 17:09'!
writeJsonWith: aWriter
	aWriter writeNull! !

!Boolean methodsFor: '*al-json-dispatch' stamp: 'cwp 3/14/2011 17:08'!
writeJsonWith: aWriter
	aWriter writeBoolean: self! !

!SequenceableCollection methodsFor: '*al-json-dispatch' stamp: 'cwp 3/14/2011 16:54'!
writeJsonWith: aWriter
	aWriter writeArray: self! !

!String methodsFor: '*al-json-dispatch' stamp: 'cwp 3/14/2011 16:53'!
writeJsonWith: aWriter
	aWriter writeString: self! !

!Integer methodsFor: '*al-json-dispatch' stamp: 'cwp 3/14/2011 17:00'!
writeJsonWith: aWriter
	aWriter writeInteger: self! !
